#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct sk
{
	char tip[30];
	char naziv[30];
	int broj;
	int balans;
	struct sk *levi,*desni;
	
}sk;

#define novi(x) x=(sk*)malloc(sizeof(sk));


int dubina(sk *p)
{
	int dd=0,dl=0;
	if (p)
	{
		if (p->levi) dl=dubina(p->levi);
		if (p->desni) dd=dubina(p->desni);
		if (dd>dl) return dd++;
		else return dl++;	
	}
}

void lrotacija(sk **p)
{
	sk *pomd,*poml;
	poml=*p;
	pomd=poml->desni;
	poml->desni=pomd->levi;
	pomd->levi=poml;
	*p=pomd;
	
	pomd->balans=dubina(pomd->desni)-dubina(pomd->levi);
	poml->balans=dubina(poml->desni)-dubina(poml->levi);
}

void drotacija(sk **p)
{
	sk *pomd,*poml;
	pomd=*p;
	poml=pomd->levi;
	pomd->levi=poml->desni;
	poml->desni=pomd;
	*p=poml;
	
	pomd->balans=dubina(pomd->desni)-dubina(pomd->levi);
	poml->balans=dubina(poml->desni)-dubina(poml->levi);
}

int dodaj(sk **p,char tip[],char naziv[],int br)
{
	sk *t=*p;
	int ink,rez;
			
	if (t==NULL)
	{
		novi(t);
		strcpy(t->tip,tip);
		strcpy(t->naziv,naziv);
		t->broj=br;
		t->desni=t->levi=NULL;
		t->balans=0;
		rez=1;
	}
	else
	{	
		if (strcmp(tip,t->tip)!=0)
		{
		if (strcmp(tip,t->tip)>0) ink=dodaj(&(t->desni),tip,naziv,br);
		else ink=-dodaj(&(t->levi),tip,naziv,br);
		}
		else
		{
		if (strcmp(naziv,t->naziv)>0) ink=dodaj(&(t->desni),tip,naziv,br);
		else ink=-dodaj(&(t->levi),tip,naziv,br);
		}
		t->balans+=ink;
		
		if (ink!=0 && t->balans!=0)
		{
			if (t->balans<0)
			{
				if (t->levi->balans<-1) drotacija(&t);
				else
				{
					lrotacija(&(t->levi));
					drotacija(&t);
				}
			}
			else if (t->balans>0)
			{
				if (t->desni->balans>1) lrotacija(&t);
				else
				{
					drotacija(&(t->desni));
					lrotacija(&t);
				}
			}
			else rez=1;
		}
	}
	*p=t;
	return rez;
	
	
}


sk *form(char fajl[])
{
	FILE *f;
	sk *p=NULL;int i,n,br;
	f=fopen(fajl,"r");
	fscanf(f,"%d",&n);
	
	char tip[30],naziv[30];
	for (i=0;i<n;i++)
	{
		fscanf(f,"%s",tip);
		fscanf(f,"%s",naziv);
		fscanf(f,"%d",&br);
	printf("%s\t%s\t%d \n",tip,naziv,br);
		dodaj(&p,tip,naziv,br);
	}
	return p;
}

void ispis(sk *p)
{
	if (p)
	{
		
		ispis(p->desni);
		printf("%s\t%s\t%d\n",p->tip,p->naziv,p->broj);
		ispis(p->levi);
	}
}
/*
void brisi(sk *p,char tip[],char naziv[],int br)
{
	
	if (p)
	{
		if (p->desni) brisi(p->desni,tip,naziv,br);
		if (strcmp(p->tip,tip)==0 && (p->naziv,naziv)==0)
		{
			p->broj-=br;
		}
		if (p->levi) brisi(p->levi,tip,naziv,br);
		
		
	}
}

void brisi2(sk *p,sk **y)
{
	
	if (p)
	{
		if (p->desni) brisi(p->desni,y);
		if (p->broj>0)
		{
			dodaj(y,p->tip,p->naziv,p->broj);
		}
		if (p->levi) brisi(p->levi,y);
		
		
	}
}*/
void kolikoi(sk *p,char naziv[],int *bri)
{
	if (p)
	{
		if (p->desni) kolikoi(p->desni,naziv,bri);
		if (strcmp(naziv,p->naziv)==0)
		{
			(*bri)++;
		}
		if (p->levi) kolikoi(p->levi,naziv,bri);
		
		
	}
}
void koliko(sk *p,char t[],int l,int *br, int *bri)
{
	if (p)
	{
		if (p->desni) koliko(p->desni,t,l,br,bri);
		if (strcmp(t,p->tip)==0)
		{
			kolikoi(p,p->naziv,bri);
			(*br)++;
		}
		if (p->levi) koliko(p->levi,t,l,br,bri);
		
		
	}
}
main(int argc,char *argv[])
{
	sk *p=NULL;
	p=form(argv[1]);
	
	ispis(p);
	/*FILE *f;
	f=fopen(argv[2],"r");
	int i,n,br;
	fscanf(f,"%d",&n);
	
	char tip[30],naziv[30];
	
	for (i=0;i>n;i++)
	{
		fscanf(f,"%s",tip);
		fscanf(f,"%s",naziv);
		fscanf(f,"%d",&br);
		brisi(p,tip,naziv,br);
	}
	
	sk *y=NULL;
	brisi2(p,&y);
	ispis(y);
	printf("unesi tip T\n");
	char t[30];
	scanf("%s",t);
	printf("unesi P\n");
	int l;
	scanf("%d",&l);
	br=0;
	int bri=0;
	koliko(p,t,l,&br,&bri);
	int r;
	r=br-bri+1;
	printf("ime ih %d \n",r);*/
	
	
}
