#include<stdio.h>
#include<stdlib.h>
#include<string.h>

//global suma=0;

typedef struct Cvor
{
	char *tip;
	char *naziv;
	int broj;
	int balans;
	struct Cvor *levi,*desni;
}cvor;

int dubina(cvor *p)
{
	int dd=0,dl=0;
	if(p)
	{
		if(p->levi) dl=dubina(p->levi);
		if(p->desni) dd=dubina(p->desni);
		if(dd>dl) return dd++;
		else return dl++;
	}
	else return 0;
}

void levarotacija(cvor **p)
{
	cvor *poml,*pomd;
	poml=(*p);
	pomd=poml->desni;
	poml->desni=pomd->levi;
	pomd->levi=poml;
	(*p)=pomd;
	
	poml->balans=dubina(poml->desni)-dubina(poml->levi);
	pomd->balans=dubina(pomd->desni)-dubina(pomd->levi);
}

void desnarotacija(cvor **p)
{
	cvor *poml,*pomd;
	pomd=(*p);
	poml=pomd->levi;
	pomd->levi=poml->desni;
	poml->desni=pomd;
	(*p)=poml;
	
	poml->balans=dubina(poml->desni)-dubina(poml->levi);
	pomd->balans=dubina(pomd->desni)-dubina(pomd->levi);
}

void unos(cvor **p)
{
	cvor *pom,*temp;
	int n,i;
	char s[50];
	pom=(*p);
	printf("Uneti broj proizvoda:\n");
	scanf("%d",&n);
	getchar();
	for(i=0;i<n;i++)
	{
		temp=(cvor *)malloc(sizeof(cvor));
		temp->levi=temp->desni=NULL;
		printf("Uneti tip proizvoda:\n");
		gets(s);
		temp->tip=(char *)malloc(sizeof(char)*strlen(s+1));
		strcpy(temp->tip,s);
		printf("Uneti naziv proizvoda:\n");
		gets(s);
		temp->naziv=(char *)malloc(sizeof(char)*strlen(s+1));
		strcpy(temp->naziv,s);
		printf("Uneti broj komada proizvoda:\n");
		scanf("%d",&temp->broj);
		getchar();
		dodaj(&pom,temp);
	}
	(*p)=pom;
}

int dodaj(cvor **p,cvor *temp)
{
	int rez=0,inkrement;
	cvor *pom;
	pom=(*p);
	
	if(pom==NULL)
	{
		pom=temp;
		pom->balans=0;
		rez=1;
	}
	else 
	{
		if((((strcmp(pom->tip,temp->tip))<0) || 
		(((strcmp(pom->tip,temp->tip))==0) && 
		((strcmp(pom->naziv,temp->naziv))<0))))
		{
			inkrement=dodaj(&(pom->desni),temp);
		}
		else inkrement=-dodaj(&(pom->levi),temp);
		
		pom->balans=pom->balans+inkrement;
		
		if((pom->balans!=0)&&(inkrement!=0))
		{
			if(pom->balans<-1)
			{
				if(pom->levi->balans<0) desnarotacija(&pom);
				else { levarotacija(&(pom->levi)); desnarotacija(&pom); }
			}
			else if(pom->balans>1)
			{
				if(pom->desni->balans>0) levarotacija(&pom);
				else { desnarotacija(&(pom->desni)); levarotacija(&pom); }
			}
			else rez=1;
		}	
	}
	(*p)=pom;
	return rez;
}

void ispis(cvor *p)
{
	if(p)
	{
		if(p->desni) ispis(p->desni);
		printf("%s %s %d\n",p->tip,p->naziv,p->broj);
		if(p->levi) ispis(p->levi);
	}
}

void nadji(cvor *p,char s[50],int b)
{
	if(p)
	{
		
		if((strcmp(p->tip,s))==0)
		{
			if(p->broj<b)
			suma=suma+1;
		}
		if(p->levi) nadji(p->levi,s,b);
		if(p->desni) nadji(p->desni,s,b);
	}
}

main()
{
	cvor *p=NULL;
	char s[50];
	int b,suma=0;
	unos(&p);
	ispis(p);
	printf("Uneti trazeni tip proizvoda:\n");
	gets(s);
	printf("Uneti trazeni broj proizvoda:\n");
	scanf("%d",&b);
	nadji(p,s,b);
	printf("Ima ih:%d\n",suma);
}



