#include<stdio.h>
#include<stdlib.h>
#include<string.h>

typedef struct drvo
{
	char tip[50];
	char naziv[50];
	int broj;
	int bal;
	struct drvo *levi,*desni;
} DRVO;

int Dubina(DRVO *p)
{
	int dl=0;
	int dd=0;
	
	if(p)
	{
		if(p->levi) dl=Dubina(p->levi);
		if(p->desni) dd=Dubina(p->desni);
		if(dl>dd) return ++dl;
		else return ++dd;
	}
	else return 0;
}

DRVO *lrotacija(DRVO *p)
{
	DRVO *pom;
	pom=p->desni->levi;
	p->desni->levi=p;
	p=p->desni;
	p->levi->desni=pom;
	
	p->levi->bal=Dubina(p->levi->desni)-Dubina(p->levi->levi);
	p->bal=Dubina(p->desni)-Dubina(p->levi);
	return p;
}

DRVO *drotacija(DRVO *p)
{
	DRVO *pom;
	pom=p->levi->desni;
	p->levi->desni=p;
	p=p->levi;
	p->desni->levi=pom;
	
	p->desni->bal=Dubina(p->desni->desni)-Dubina(p->desni->levi);
	p->bal=Dubina(p->desni)-Dubina(p->levi);
	return p;
}

int Dodaj(DRVO **p2,DRVO *temp)
{
	DRVO *p;
	int rezultat,ink;
	
	rezultat=0;
	p=(*p2);
	
	if(p==NULL)
	{
		p=temp;
		p->levi=NULL;
		p->desni=NULL;
		p->bal=0;
		rezultat=1;
	}
	else
	{
		if(strcmp(temp->tip,p->tip)>0 || (strcmp(temp->tip,p->tip)==0 && strcmp(temp->naziv,p->naziv)>0))
		ink=Dodaj(&(p->desni),temp);
		else
		ink=-Dodaj(&(p->levi),temp);
		p->bal+=ink;
		
		if(p->bal!=0 && ink!=0)
		{
			if(p->bal<-1)
			{
				if(p->levi->bal<0)
				{
					p=drotacija(p);
				}
				else
				{
					p->levi=lrotacija(p->levi);
					p=drotacija(p);
				}
			}
			else if(p->bal>1)
			{
				if(p->desni->bal>0)
				{
					p=lrotacija(p);
				}
				else
				{
					p->desni=drotacija(p->desni);
					p=lrotacija(p);
				}
			}
			else rezultat=1;
		}
	}
	
	*p2=p;
	return rezultat;
}

void Kreiraj(DRVO **p2)
{
	DRVO *temp,*p;
	
	char tip[50];
	char naziv[50];
	int broj;
	
	int i,n;
	
	p=(*p2);
	printf("UNESI N: \n");
	scanf("%d",&n);
	getchar();
	
	for(i=0;i<n;i++)
	{
		temp=malloc(sizeof(DRVO));
		
		gets(temp->tip);
		gets(temp->naziv);
		scanf("%d",&temp->broj);
		getchar();
		
		Dodaj(&p,temp);
	}
	
	*p2=p;
	
}

void Ispis(DRVO *p)
{
	if(p)
	{
		Ispis(p->levi);
		printf("%s \t %s \t %d \t %d \n",p->tip,p->naziv,p->broj,p->bal);
		Ispis(p->desni);
	}
}

main()
{
	DRVO *p=NULL;
	Kreiraj(&p);
	Ispis(p);
}
