#include <stdio.h>
#include <stdlib.h>
#include <string.h>

struct kupac
{
    char ime[30];
    int br_hleba;
    int br_peciva;
    int bod;
    struct kupac *sledeci;
};



struct kupac * form(int);
struct kupac * dodaj(struct kupac *,char *, int, int);
void pobednik(struct kupac *, int , int *);
void pisi(struct kupac *);


struct kupac *NapraviNovi (char *, int , int );



int main(void)
{
    struct kupac *p =NULL;
    int d;
    printf("Uneti d (d>=1) ");
    scanf("%d",&d);


    p =form(d);

    printf("Uneti B ");
    scanf("%d",&d);

    int i = 0;
    pobednik(p,d,&i);

//    printf("Hello World!\n");
    return 0;
}


struct kupac *NapraviNovi (char *ime, int hleb, int pecivo)
{

    struct kupac *novi;
    novi = (struct kupac *) malloc(sizeof(struct kupac));
    if(novi == NULL)
    {
        printf("Greska pri alokacjij memorije");
        exit(0);
    }

    strcpy(novi->ime, ime);
    novi->br_hleba = hleb;
    novi->br_peciva = pecivo;
    novi->bod = hleb + pecivo/2 ;
    novi->sledeci = NULL;

    return novi;
}

struct kupac*dodaj(struct kupac *p,char *ime, int hleb, int pecivo)
{
    struct kupac *pom,*prethodni, *novi;
    if(p == NULL)
    {
        novi = NapraviNovi(ime, hleb,pecivo);
        return novi;
    }
    else
    {
        pom = p;
        prethodni = NULL;

        while(pom != NULL && strcmp(pom->ime , ime) != 0)
        {
            prethodni = pom;
            pom = pom->sledeci;
        }
        if(pom == NULL)
        {
            novi = NapraviNovi(ime, hleb,pecivo);
            prethodni->sledeci = novi;
        }
        else
        {
            int poeni = hleb + pecivo/2 ;
            // pisace nov broj hleba i peciva
            prethodni->br_hleba = hleb;
            prethodni->br_peciva = pecivo;
            prethodni->bod += poeni;
        }
    }

    return p;

}

void pisi(struct kupac *p)
{
    if(p == NULL) printf("Prazna lista");
    else
    {
        while(p!=NULL)
        {
            printf("%s  %d %d %d",p->ime,p->br_hleba, p->br_peciva, p->bod);
            p = p->sledeci;
        }
    }
}

struct kupac *form(int D)
{
    struct kupac *p = NULL;
    char ime [30];
    int hleb, peciva;
    printf("umesite n");
    int n;
    scanf("%d",&n);
    while(n)
    {
        n--;
        printf("Unesite ime ");
        scanf("%s",ime);
        printf("unesite broj hleba ");
        scanf("%d",&hleb);
        printf("unesite broj peciva ");
        scanf("%d", &peciva);

        p = dodaj(p,ime, hleb, peciva);

    }

    pisi(p);

    // upisan prva dan, ostalo jos D-1

    int i, k;
    for(i=2; i<=D;i++)
    {
        printf("dan %d \n\n", i);


        printf("uneti K");
        scanf("%d",&k);

        while(k)
        {
            k--;
            printf("Unesite ime ");
            scanf("%s",ime);
            printf("unesite broj hleba ");
            scanf("%d",&hleb);
            printf("unesite broj peciva ");
            scanf("%d", &peciva);

            p = dodaj(p,ime, hleb, peciva);

        }

    }


    // zavrsen upis
    return p;


}


void pobednik(struct kupac *p, int B, int *ind)
{
    if(p == NULL)
        return;

    pobednik(p->sledeci, B,ind);
    if( *ind == 0 && p->bod > B)
    {

        printf("%s  %d %d %d",p->ime,p->br_hleba, p->br_peciva, p->bod);
        *ind = 1;
    }
}










































