#include<stdio.h>
#include<stdlib.h>
#include<string.h>

struct broj
{
	int broj;
	int razliciti;
	struct broj *levi;
	struct broj *desni;
};

void dodaj(struct broj **p,int br);

struct broj* formiraj(FILE *f)
{
	struct broj *vrh;
	vrh=NULL;
	int n,br;
	char linija[80];
	fgets(linija,80,f);
	sscanf(linija,"%d",&n);
	while(n>0)
	{
		fgets(linija,80,f);
		sscanf(linija,"%d",&br);
		dodaj(&vrh,br);
		n--;
	}
	return vrh;
}

void dodaj(struct broj **p,int br)
{
	struct broj* t=*p;
	if(t==NULL)
	{
		t=(struct broj*)malloc(sizeof(struct broj));
		if(t==NULL)
		{
			printf("Greska pri alokaciji!");
			exit(0);
		}
		t->broj=br;
		t->razliciti=razlicitih(br);
		t->levi=NULL;
		t->desni=NULL;
	}
	else
	{
		if(razlicitih(br)>t->razliciti) dodaj(&t->desni,br);
		else dodaj(&t->levi,br);
	}
	*p=t;
}

int razlicitih(int br)
{
	int brojac=1,niz[10],k=0,i,cifra,pom=br,j;
	while(br!=0)
	{
		cifra=br%10;
		niz[k]=cifra;
		k++;
		br=br/10;
	}
	for(i=0;i<k;i++)
	for(j=i+1;j<k;j++)
	if(niz[i]!=niz[j] && j==k-1)
	brojac++;
	printf("broj razlicitih cifara u %6d: je %6d\n",pom,brojac);
	return brojac;
}

int saberi(struct broj *vrh,int k, int c)
{
	int br=0;
	if(vrh==NULL) return;
	br+=saberi(vrh->desni,k,c);
	if(vrh->broj>k && vrh->razliciti<c)
	br+=vrh->broj;
	br+=saberi(vrh->levi,k,c);
	return br;
}

void ispis(struct broj *vrh)
{
	if(vrh==NULL) return;
	ispis(vrh->desni);
	printf("%6d %6d\n",vrh->broj,vrh->razliciti);
	ispis(vrh->levi);
}

main(int argc,char* argv[])
{
	FILE *f;
	f=fopen(argv[1],"r");
	struct broj *vrh;
	vrh=NULL;
	int k,c;
	vrh=formiraj(f);
	ispis(vrh);
	printf("Unesite K:\n");
	scanf("%d",&k);
	printf("Unesite C:\n");
	scanf("%d",&c);
	printf("Zbir brojeva po zadatom kriterijumu je: %d\n",saberi(vrh,k,c));
}
