#include<stdio.h>
#include<stdlib.h>
#include<string.h>

typedef struct Proizvod
{
	char tip[10];
	char naziv[20];
	int broj;
	int balans;
	struct Proizvod *levi,*desni;
	
}proizvod;

#define novi(x) x=(proizvod*)malloc(sizeof(proizvod))

int dubina(prizvod *k)
{
	if(k)
	{
		int dd=dl=0;

		if(k->levo) dl=dubina(k->levo);
		if(k->desni) dd=dubina(k->desno);

		if(dd<dl) return ++dl;
		else return ++dd;
	}
}

void lrotacija(proizvod **k)
{
	proizvod *pomd,*poml;

	poml=*k;
	pomd=poml->desni;
	poml->desni=pomd->levi;
	pomd->levi=poml;

	*k=pomd;

	pomd->balans=dubina(pomd->desni)-dubina(pomd->levi);
	poml->balans=dubina(poml->desni)-dubina(poml->levi);
}

void drotacija(proizvod **k)
{
	proizvod *pomd,*poml;

	pomd=*k;
	poml=pomd->levi;
	pomd->levi=poml->desni;
	poml->desni=pomd;

	*k=poml;

	pomd->balans=dubina(pomd->desni)-dubina(pomd->levi);
	poml->balans=dubina(poml->desni)-dubina(poml->levi);
}

void ispis(proizvod *k)
{
	if(k)
	{
		if(k->desni) ispis(k->desni);
		printf("%s ",k->tip);
		printf("%s ",k->naziv);
		printf("%s ",k->broj)
		if(k->levi) ispis(k->levi);
	}
}

int dodaj(proizvod **k,char tip[],char naziv[],int broj)
{
	int inktrment,rezultat=0;
	proizvod *pom;
	pom=*k;
	
	if(pom==NULL)
	{
		novi(pom);
		strcpy(pom->tip,tip);
		strcpy(pom->naziv,naziv);
		pom->broj=broj;
		pom->balans=0;
		rezultat=1;
		pom->levi=pom->desni=NULL;
	}
	else
	{	
		if(strcmp(tip,pom->tip)<0) inkrement=-dodaj(&(pom->levi),tip,naziv,broj);
		else if(strcmp(tip,pom->tip)>0) inkrement=dodaj(&(pom->desni),tip,naziv,broj);
		else if(strcmp(naziv,pom->naziv)<0) inkrement=-dodaj(&(pom->levi),tip,naziv,broj);
		else inkrement=-dodaj(&(pom->levi),tip,naziv,broj);

		pom->balans += inkrement;

		if(pom->balans!=0 && inkrement !=0)
		{
			if(pom->balans < -1)
			{
				if(pom->levi->balans<0) drotacija(&pom);
				else {lrotacija(&(pom->desni)); drotacija(&pom)}
			}
			if(pom->balans > 1)
			{
				if(pom->desni->balans<0) lrotacija(&pom);
				else {drotacija(&(pom->levi)); lrotacija(&pom)}
			}
		else rezultat=1;
		}
	}
	*k=pom;

	return rezultat;
}

proizvo *form()
{
	proizvod *k;
	k=NULL;
	int n,i;

	printf("Unesi n: ");
	scanf("%d",&n);
	
	for(i=0;i<n;i++)
	{
		printf("Unesi naziv: ");
		scanf("%s",naziv);
		printf("Unesi tip: ");
		scanf("%s",tip);
		printf("Unesi broj: ");
		scanf("%d",&broj);

		dodaj(**k,tip,naziv,broj);
	}
	
}

/*void brisi(proizvod *k,proizvod **novo,int K)
{
	if(k)
	{
		if(k->desni) brisi(k->desni,novo,K);
		K=dodaj(K,);
		if(k->levi) brisi(k->levi,novo,K);
	}
}*/

main()
{
	prizvod *k,*novo;
	k=novo=NULL;
	int K;	

	k=form();
	
	ispis(k);

	printf("Unesi K narudzbenica: ");
	scanf("%d",&K);
	
	//brisi(k,&novo,K)
	
}









