#include <stdio.h>
#include <stdlib.h>
#include <string.h>

struct drvo
{
	struct drvo *levi,*desni;
	char tip[20];
	char naziv[20];
	int broj;
	int balans;
};

#define novi(x) x = (struct drvo*)malloc(sizeof(struct drvo))

struct drvo *form(int);
int dodaj(struct drvo **p,char tip[20],char naziv[20],int broj);
void ispis(struct drvo *);
int dubina(struct drvo *);
void lrotacija(struct drvo**);
void drotacija(struct drvo**);
//int prebroj(struct drvo *p,char t[20],int p);

int main()
{
	struct drvo *p;
	int n;
	printf("Unesite broj n:\n");
	scanf("%d",&n);
	p = form(n);
	//putchar('\n');
	getchar();
	ispis(p);
	putchar('\n');
	/*struct drvo *q = NULL;
	q = obrisi(p);
	ispis(q);*/
	/*printf("Unesite tip T:\n");
	char t[20];
	scanf("%s",t);
	printf("Unesite broj komada P:\n");
	int p;
	scanf("%d",&p);
	printf("Ima %d proizvoda.\n",prebroj(p,t,p));*/
	
	return 0;
}

void ispis(struct drvo *p)
{
	if(p)
	{
		ispis(p->levi);
		printf("%s %s %d %d\n",p->tip,p->naziv,p->broj,p->balans);
		ispis(p->desni);
	}
}

int dubina(struct drvo *p)
{
	int dd = 0,dl = 0;
	if(p)
	{
		dd = dubina(p->desni);
		dl = dubina(p->levi);
		if(dl > dd) return dl;
		else return dd;
	}
	else return 0;
}

void lrotacija(struct drvo **p)
{
	struct drvo *poml,*pomd;
	poml = *p;
	pomd = poml->desni;
	poml->desni = pomd->levi;
	pomd->levi = poml;
	*p = pomd;
	poml->balans = dubina(poml->desni) - dubina(poml->levi);
	pomd->balans = dubina(pomd->desni) - dubina(pomd->levi);
}

void drotacija(struct drvo **p)
{
	struct drvo *poml,*pomd;
	pomd = *p;
	poml = pomd->levi;
	pomd->levi = poml->desni;
	poml->desni = pomd;
	*p = poml;
	poml->balans = dubina(poml->desni) - dubina(poml->levi);
	pomd->balans = dubina(pomd->desni) - dubina(pomd->levi);
}

struct drvo *form(int n)
{
	int i,broj;
	char tip[20],naziv[20];
	struct drvo *koren;
	koren = NULL;
	for(i = 0; i < n; i ++)
	{
		printf("Unesi tip:\n");
		scanf("%s",tip);
		getchar();
		printf("Unesi naziv:\n");
		scanf("%s",naziv);
		printf("Unesi broj:\n");
		scanf("%d",&broj);
		dodaj(&koren,tip,naziv,broj);
	}
	return koren;
}

int dodaj(struct drvo **p,char tip[20],char naziv[20],int broj)
{
	int inkrement,rezultat;
	struct drvo *t;
	t = *p;
	rezultat = 0;
	if(t == NULL)
	{
		novi(t);
		if(t == NULL)
		{
			printf("Greska pri alokaciji.\n");
			exit(0);
		}
		t->balans = 0;
		rezultat = 1;
		t->levi = t->desni = NULL;
		strcpy(t->tip,tip);strcpy(t->naziv,naziv);t->broj = broj;
	}
	else
	{
		if(strcmp(tip,t->tip) > 0) inkrement = dodaj(&(t->desni),tip,naziv,broj);
		else if((strcmp(tip,t->tip) == 0)&& (strcmp(naziv,t->naziv) > 0)) inkrement = dodaj(&(t->desni),tip,naziv,broj);
		else inkrement = -dodaj(&(t->levi),tip,naziv,broj);
		t->balans += inkrement;
		if(t->balans != 0 && inkrement != 0)
		{
			if(t->balans < -1)
			{
				if(t->levi->balans < 0) drotacija(&t);
				else
				{
					lrotacija(&(t->levi));
					drotacija(&t);
				}
			}
			else if(t->balans > 1)
			{
				if(t->desni->balans > 0) lrotacija(&t);
				else
				{
					drotacija(&(t->desni));
					lrotacija(&t);
				}
			}
			else rezultat = 1;
		}
	}
	*p = t;
	return rezultat;
}
	/*	
int prebroj(struct drvo *p,char t[20],int p)
{
	int d = 0;
	if(p)
	{
		d += prebroj(p->levi,t,p);
		d += prebroj(p->desni,t,p);
	}
	if(strcmp(t,p->tip) == 0 && p->broj < p) d += 1;
	return d;
}
	*/	
	
	
	/*
struct drvo * obrisi(struct drvo *p)
{
	struct drvo *dr;
	dr = NULL;
	int k,broj;
	char tip[20],naziv[20];
	printf("Unesite k:\n");
	scanf("%d",&k);
	getchar();
	int i;
	for(i = 0;i < k; i ++)
	{
		printf("Unesi tip:\n");
		scanf("%s",tip);
		getchar();
		printf("Unesi naziv:\n");
		scanf("%s",naziv);
		printf("Unesi broj:\n");
		scanf("%d",&broj);
		dodaj(&dr,tip,naziv,broj);
	}
	return dr;
}
*/
/*
struct drvo *obrisi(struct drvo *p,char tip[20],char naziv[20],int broj)
{
	struct drvo *q = NULL;
	if(strcmp(t->tip,tip) == 0) q = obrisi(p->desni,tip,naziv,broj);
	else q = obrisi(p->levi,tip,naziv,broj);
	if(p->broj > broj) dodaj(&q,tip,naziv,p->broj - broj);
	else dodaj(&q,tip,naiv,0);
	* return q;
	* }




 */
	
